//----------------------------------------------------
// Simulator konecnostavoveho automatu
//----------------------------------------------------
// (C) Robert Novotny, 11. 5. 2003
//
// Vytvorene pre PrirF UPJS KE, KMI/LIN1.
//
// S problematikou automatov a formalnych jazykov
// sa mozno oboznamit vo vplyvnej monografii [Hu]
// (Hopcroft - Ullman: Formalne jazyky a automaty)

<?php
  class fs_automaton {
    //data
    var $data;
    //vystupna funkcia, implicitne echovany vystup
    var $output_function = "";

    //konstruktor, zatial prazdny
    function fs_automaton() {
    }

    //implicitna vystupna funkcia, mozno predefinovat v clene $outputfunction
    function default_output_function($symbol) {
      echo $symbol;
    }

    //osetrovac vystupu, podla toho, ci uzivatel zadal vlastnu vystupnu funkciu
    function output($symbol) {
      if($this->output_function == "") {
        call_user_method("default_output_function", $this, $symbol);
      } else {
        call_user_func($this->output_function, $symbol);
      }
    }

    //vyhlada nasledovnu instrukciu
    function find_instruction($symbol, $state) {
     //vrati dvojicu (vystupny_symbol, dalsi_stav) podla dat
      return array(
        "symbol" => $this->data[$symbol][$state][1],
        "state" => $this->data[$symbol][$state][0]
      );
    }

    //spusti zadany automat na danom vstupe $input, pricom $init_state
    //je pociatocny stav
    function run($input, $init_state) {
      $state = $init_state;
      //nacitavame vstup
      for($i = 0; $i < strlen($input); $i++) {
        //poznacime si aktualne citany symbol
        $symbol = $input[$i];
        //najdeme dalsi stav a vystupny symbol (find_instruction zodpoveda funkcii <i>f</i>
        //v definicii KSA
        $next_instruction = $this->find_instruction($symbol, $state);
        //vypiseme symbol
        $this->output($next_instruction["symbol"]);
        //sme v dalsom stave, v dalsom kole nacitame znak atd...
        $state = $next_instruction["state"];
      }
    }
  }

  //priklad pouzitia (na <i>a</i> dava minus, a pri kazdom druhom <i>b</i> dava +
  $ksa = new fs_automaton();
  $ksa->data["a"]["q_0"] = array("q_0", "-");
  $ksa->data["a"]["q_1"] = array("q_1", "-");
  $ksa->data["b"]["q_0"] = array("q_1", "-");
  $ksa->data["b"]["q_1"] = array("q_0", "+");

  $ksa->run("aaababaa", "q_0");
?>